namespace CMSMicroservice.Application.UserWalletCQ.Commands.CreateNewUserWallet;
public class CreateNewUserWalletCommandValidator : AbstractValidator<CreateNewUserWalletCommand>
{
    public CreateNewUserWalletCommandValidator()
    {
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.Balance)
            .NotNull();
        RuleFor(model => model.NetworkBalance)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserWalletCommand>.CreateWithOptions((CreateNewUserWalletCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
